PROGRAM Tests_ViewText_and_Text_Stream;

{$DEFINE DEBUGTEXT}
{$F+,O+,I-,D+,L+,R+,S+}


USES Crt, Dos, Def, TWindow, Fkey11, LcText, ViewT;

VAR
   ft : TEXT;
   number : BYTE;
   num : LONGINT;
   help : ViewText;
   Stroka : StandartString;
   Stream : LocationTextPtr;
   Index : LONGINT;
   Line : STRING;
   LnPtr : RecLinePtr;
   Wind : TextWindowPtr;

{----------------------------------------------------------}

PROCEDURE func_help;

VAR
   ch : CHAR;
   HelpWindow : TextWindow;

BEGIN
     WITH HelpWindow DO
          BEGIN
               MakeWindow ( 8, 6, 50, 18 , RED, WHITE );
               WPrint ( 2, 4, '         蠬 :'  );
               WPrint ( 2, 5, '       '+#24+' , '+#25+' , Pg/up , Pg/Dn ' );
               WPrint ( 2, 8, '             F1  ESC ' );
               TypeFrameWindow ( #196 );
               REPEAT
                     ch := READKEY;
                     IF ( KEYPRESSED ) THEN
                        ch := READKEY
               UNTIL ( ch = #27 );
               UnFrameDone ( #196 )
          END

END; { procedure help }

{----------------------------------------------------------}

PROCEDURE ShowStream;

BEGIN
     AnyKey;
     NEW ( Wind, MakeWindow ( 4,4 ,76, 21, CYAN, BLUE ) );
     Wind^.TypeFrameWindow ( #205 );
     WITH help DO
          BEGIN
               init ( Wind, Stream );
               SetState ( TRUE, FALSE );
               set_key ( f1, func_help );
               num := 1;
               control_inf ( num )
          END;
     help.done;
     DISPOSE ( Wind, UnFrameDone ( #196 ) );
     WINDOW ( 1, 1, 80, 25 );
     TEXTBACKGROUND ( BLACK );
     TEXTCOLOR ( WHITE );
     CLRSCR

END; { procedure ShowStream }

{----------------------------------------------------------}

BEGIN
     ASSIGN ( ft, 'TESTS.TXT' );
     {$I+}
     REWRITE ( ft );
     FOR Index := 1 TO 99 DO
         WRITELN ( FT, ' ப  - ', Index );
     WRITE ( FT, '/****************************/' );
     CLOSE ( ft );
     CLRSCR;
     NEW ( Stream, Init ( 1024, 'TESTS.TXT' ) );
     WRITELN;
     WRITELN ( '⪠ ⠭ ப #', Stream^.GetSize - 1 );
     Stream^.SetLineNumber ( Stream^.GetSize - 1 );
     WRITELN ( 'ப  ⮪ - ', Stream^.GetSize );
     WRITELN ( '祭 ।᫥ ப ⮪' );
     Stream^.TruncateLines;
     WRITELN ( 'ப  ⮪ - ', Stream^.GetSize );
     AnyKey;
     FOR Index := Stream^.GetSize DOWNTO 1 DO
         BEGIN
              WRITELN ( '⪠ ⠭ ப #', Index );
              Stream^.SetLineNumber ( Index );
              WRITELN ( '⪠  ப #', Index );
              Stream^.ReadLine ( Line );
              WRITELN ( Line );
              WRITELN;
         END;
     WRITELN;
     Index := Stream^.GetSize DIV 2;
     Stream^.SetLineNumber ( Index );
     WRITELN ( 'ப  䠩 - ', Stream^.GetSize );
     WRITELN ( '⪠ 㤠 ப ', Index, ', ', Index + 1 );
     Stream^.DelLines ( 2 );
     WRITELN ( 'ப  䠩 - ', Stream^.GetSize );
     Index := 1;
     Stream^.SetLineNumber ( Index );
     WRITELN ( '⪠ 㤠 ப ', Index, ', ', Index + 1 );
     Stream^.DelLines ( 2 );
     WRITELN ( 'ப  䠩 - ', Stream^.GetSize );
     Index := Stream^.GetSize - 1;
     Stream^.SetLineNumber ( Index );
     WRITELN ( '⪠ 㤠 ப ', Index, ', ', Index + 1 );
     Stream^.DelLines ( 2 );
     WRITELN ( 'ப  䠩 - ', Stream^.GetSize );
     WRITELN;
     WRITELN ( 'ப  䠩 - ', Stream^.GetSize );
     WRITELN ( '⪠  ப  䠩' );
     Stream^.AddLine ( '/**********************/' );
     WRITELN ( 'ப  䠩 - ', Stream^.GetSize );
     Stream^.SetLineNumber ( Stream^.GetSize );
     WRITELN ( '⪠ ⠢ ।᫥ ப  䠩' );
     Stream^.InsLine ( ' ப  - 99    /INS/' );
     WRITELN ( 'ப  䠩 - ', Stream^.GetSize );
     WRITELN ( '⪠ ⠢  2 ப  䠩' );
     Stream^.SetLineNumber ( 1 );
     Stream^.InsLine ( ' ப  - 2    /INS/' );
     Stream^.SetLineNumber ( 1 );
     Stream^.InsLine ( ' ப  - 1    /INS/' );
     WRITELN ( 'ப  䠩 - ', Stream^.GetSize );
     WRITELN;
     Stream^.SetLineNumber ( 2 );
     WRITELN ( 'ப  䠩 - ', Stream^.GetSize );
     WRITELN ( '⪠  70  ப ⮪' );
     AnyKey;
     LnPtr := NIL;
     Stream^.ReadLines ( 70, LnPtr );
     WRITELN ( '⪠ 㤠 70  ப ⮪' );
     AnyKey;
     Stream^.SetLineNumber ( 2 );
     Stream^.DelLines ( 70 );
     WRITELN ( 'ப  䠩 - ', Stream^.GetSize );
     Stream^.ReSetStream;
     WRITELN ( 'ப  䠩 ᫥ ⠭ - ', Stream^.GetSize );
     Stream^.SetLineNumber ( Stream^.GetSize );
     Stream^.ReadLine ( Line );
     WRITE ( Line );
     AnyKey;
     WRITELN ( '⪠ ⠭ ० 㤠 ப' );
     Stream^.SetLineNumber ( 2 );
     Stream^.InsertLines ( 70, LnPtr );
     WRITELN ( 'ப  䠩 - ', Stream^.GetSize );
     Stream^.ReSetStream;
     WRITELN ( 'ப  䠩 ᫥ ⠭ - ', Stream^.GetSize );
     AnyKey;
     WRITELN ( '  䠩 70 ப' );
     Stream^.Addlines ( 70, LnPtr );
     WRITELN ( 'ப  䠩 - ', Stream^.GetSize );
     Stream^.ReSetStream;
     WRITELN ( 'ப  䠩 ᫥ ⠭ - ', Stream^.GetSize );
     ClearListRecLine ( LnPtr );
     WRITELN ( '塞 ᫥ 70 ப' );
     Stream^.SetLineNumber ( Stream^.GetSize - 70 );
     Stream^.DelLines ( 70 );
     WRITELN ( 'ப  䠩 - ', Stream^.GetSize );
     Stream^.ReSetStream;
     WRITELN ( 'ப  䠩 ᫥ ⠭ - ', Stream^.GetSize );
     ShowStream;
     DISPOSE ( Stream, Done )

END.