

         {----------------------------------------------------}
         {      ViewLT  V 1.1   TURBO SUPPORT     }
         {      ணࠬ஢ Turbo Pascal  V 6.0      }
         {----------------------------------------------------}
         {  ᫥  :  30/12/1991             }
         {----------------------------------------------------}
         {  ।祭  ࠡ⪨ ⥪⮢ ⮪}
         {           ᬮ  ⬥⪨ ப ⥪       }
         {----------------------------------------------------}
         { (c) 1991,  ᫠                            }
         {----------------------------------------------------}

UNIT ViewLT;

{$IFDEF DEBUGVIEW}
      {$D+,L+,R+,S+}
{$ELSE}
      {$D-,L-,R-,S-}
{$ENDIF}

{$F+,O+,I-,V-,B-,A+}

INTERFACE

USES Crt, Dos, Fkey11, Def, TWindow, LcText, ViewT;

CONST
     MaxNumberInsertLines = $4000;
        { ᨬ ᬠਢ  쥪 ⢮ ப }

TYPE
    ViewLineTextPtr = ^ViewLineText;
                   { ⥫  쥪 ப  }

    ViewLineText = OBJECT  ( ViewText )
                { 쥪 騩 ⬥ ப ⥪⮢
                  ᪠                     }

                ControlLine : ARRAY [ 1 .. MaxNumberInsertLines ] OF BYTE;
                              { ଠ  ப ⥪ }

                ColorText : BYTE;
                              { 梥 ⥪ }

                ColorFon : BYTE;
                              { 梥 ᭮ 䮭 }

                ColorHelp : BYTE;
                              { 梥 䮭 ᪠ }

                ColorSymHelp : BYTE;
                              {  ᨬ ப ᪠ }

                ColorInsert : BYTE;
                              { 梥 뤥 ப }

                NumberHelpLine : LONGINT;
                               {  ᯮ⥫쭮 ப }

                CONSTRUCTOR Init ( WindPtr : TextWindowPtr;
                                   Stream : POINTER );
                          { 樠 쥪 }

                PROCEDURE SetColorText ( Cl : BYTE ); VIRTUAL;
                          { ⠭ 梥 ⥪   }

                PROCEDURE SetColorFon ( Cl : BYTE ); VIRTUAL;
                          { ⠭ 梥 䮭   }

                PROCEDURE SetColorHelp ( Cl : BYTE ); VIRTUAL;
                          { ⠭ 梥 䮭 ⨢ ப }

                PROCEDURE SetSymbolHelp ( Cl : BYTE );
                          { ⠭ 梥ᨬ ⨢ ப }

                PROCEDURE SetColorInsert ( Cl : BYTE ); VIRTUAL;
                          { ⠭ 梥 ᨬ 뤥 ப }

                PROCEDURE Show_Inf; VIRTUAL;
                          {   ⥪饥 ﭨ ଠ樨  }
                          {           ⨢஢           }

                PROCEDURE Control_Inf ( VAR ext_byte : LONGINT ); VIRTUAL;
                          { 楤 ࠢ ଠ樥  }
                          {        ⨢஢        }

                PROCEDURE SetLineNumber ( Num : LONGINT );
                          { ⠭ ⨢ ப    }

                FUNCTION TestLine ( num : LONGINT ) : BYTE; VIRTUAL;
                         { ஢ઠ  ப  稥 }
                         {            䫠 ⬥⪨            }

                PROCEDURE line_down; VIRTUAL;  { 㯯 楤       }
                PROCEDURE line_up;   VIRTUAL;  { ࠢ ⥪⮢ }
                PROCEDURE window_down; VIRTUAL;{ ଠ樥      }
                PROCEDURE window_up;  VIRTUAL;
                PROCEDURE Insert;     VIRTUAL;
                PROCEDURE TextEnd;    VIRTUAL;
                PROCEDURE TextHome;   VIRTUAL;

                DESTRUCTOR Done;
                         { 樠 쥪 }

                DESTRUCTOR DoneWithStream;
                         { 樠 쥪   ⮪ }

                END; { object ViewLineText }

    ViewLineNumberText = OBJECT  ( ViewLineText )
                { 쥪 騩 ⬥ ப ⥪⮢
                  ᪠      ࠬ          }

                LastNumber : BYTE;

                CONSTRUCTOR Init ( WindPtr : TextWindowPtr;
                                   Stream : POINTER );
                          { 樠 쥪 }

                PROCEDURE Show_Inf; VIRTUAL;
                          {   ⥪饥 ﭨ ଠ樨  }
                          {           ⨢஢           }

                PROCEDURE Insert;     VIRTUAL;

                END; { object ViewLineNumberText }

IMPLEMENTATION

{----------------------------------------------------------}

PROCEDURE FatalError ( Line : STRING );

BEGIN
     WINDOW ( 1, 1, 80, 25 );
     TEXTBACKGROUND ( BLACK );
     TEXTCOLOR ( LIGHTGRAY );
     CLRSCR;
     WRITELN ( #07 );
     WRITELN ( '᪨ ᡮ  쥪 ViewLineText' );
     WRITELN ( Line );
     WRITELN ( '믮 ணࠬ ४頥,'
              ,' 頩  ணࠬ' );
     HALT ( 1 )

END; { procedure FatalError }

{----------------------------------------------------------}

PROCEDURE ViewLineText.line_down;

BEGIN
     IF ( NumberHelpLine >= end_number ) THEN
        NumberHelpLine := End_Number
     ELSE
         INC ( NumberHelpLine );
     IF ( ( ( end_number - number + 1 ) > size_y ) AND
          ( NumberHelpLine > ( number + size_y - 1 ) ) ) THEN
        INC ( number )

END; { procedure ViewLineText.line_down }

{----------------------------------------------------------}

PROCEDURE ViewLineText.line_up;

BEGIN
     IF ( NumberHelpLine <= 1 ) THEN
        BEGIN
             NumberHelpLine := 1;
             number := 1;
             EXIT
        END;
     DEC ( NumberHelpLine );
     IF ( ( number > 1 ) AND ( NumberHelpLine < number ) ) THEN
        DEC ( number )

END; { procedure ViewLineText.line_up }

{----------------------------------------------------------}

PROCEDURE ViewLineText.SetLineNumber ( Num : LONGINT );

          { ⠭ ⨢ ப    }
VAR
   Quantity : LONGINT;
   Index : LONGINT;

BEGIN
     IF ( ( Num = NumberHelpLine ) OR ( Num < 1 ) OR
          ( Num > TextStream^.GetSize ) ) THEN
        EXIT;
     Quantity := ABS ( Num - NumberHelpLine );
     IF ( Num > NumberHelpLine ) THEN
        FOR Index := 1 TO Quantity DO
            line_down
     ELSE
         FOR Index := 1 TO Quantity DO
             line_up

END; { procedure ViewLineText.SetLineNumber }

{----------------------------------------------------------}

PROCEDURE ViewLineText.window_up;

BEGIN
     NumberHelpLine := NumberHelpLine - size_y;
     IF ( NumberHelpLine < 1 ) THEN
        NumberHelpLine := 1;
     number := number - size_y;
     IF ( number < 1 ) THEN
        number := 1;
     IF ( NumberHelpLine < number ) THEN
        NumberHelpLine := number;
     IF ( NumberHelpLine > ( number + size_y - 1 ) ) THEN
        NumberHelpLine := number + size_y - 1

END; { procedure ViewLineText.window_up }

{----------------------------------------------------------}

PROCEDURE ViewLineText.TextHome;

BEGIN
     number := 1;
     NumberHelpLine := 1

END; { procedure ViewLineText.TextHome }

{----------------------------------------------------------}

PROCEDURE ViewLineText.TextEnd;

BEGIN
     number := End_Number - size_y + 1;
     NumberHelpLine := End_Number

END; { procedure ViewLineText.TextEnd }

{----------------------------------------------------------}

PROCEDURE ViewLineText.window_down;

BEGIN
     ClearListRecLine ( LinesList );
     LinesList := NIL;
     NumberHelpLine := NumberHelpLine + size_y;
     IF ( NumberHelpLine > end_number ) THEN
        BEGIN
             TextEnd;
             EXIT
        END;
     number := number + size_y;
     IF ( number > ( end_number - size_y + 1 ) ) THEN
        number := end_number - size_y + 1

END; { procedure ViewLineText.wind_down }

{----------------------------------------------------------}

PROCEDURE ViewLineText.Insert;

BEGIN
     IF ( NumberHelpLine > MaxNumberInsertLines ) THEN
        EXIT;
     IF ( ControlLine [ NumberHelpLine ] = 0 ) THEN
         ControlLine [ NumberHelpLine ] := 1
     ELSE
         ControlLine [ NumberHelpLine ] := 0

END; { procedure ViewLineText.Insert }

{----------------------------------------------------------}

CONSTRUCTOR ViewLineText.Init ( WindPtr :TextWindowPtr; Stream : POINTER );

           { 樠 쥪 }
VAR
   indx : WORD;

BEGIN
     ViewText.Init ( WindPtr, Stream );
     FOR indx := 1 TO MaxNumberInsertLines DO
         ControlLine [ indx ] := 0;
     SetColorText ( BLUE );
     SetColorFon ( CYAN );
     SetColorHelp ( RED );
     SetColorInsert ( YELLOW );
     NumberHelpLine := 1;
     SingAlt := FALSE

END;  { constructor ViewLineText.Init }

{----------------------------------------------------------}

PROCEDURE ViewLineText.SetColorText ( Cl : BYTE );

          { ⠭ 梥 ⥪   }
BEGIN
     ColorText := Cl;
     ColorSymHelp := Cl

END;  { procedure ViewLineText.SetColorText }

{----------------------------------------------------------}

PROCEDURE ViewLineText.SetColorFon ( Cl : BYTE );

          { ⠭ 梥 䮭   }
BEGIN
     ColorFon := Cl

END;  { procedure ViewLineText.SetColorFon }

{----------------------------------------------------------}

PROCEDURE ViewLineText.SetSymbolHelp ( Cl : BYTE );

          { ⠭ 梥ᨬ ⨢ ப }
BEGIN
     ColorSymHelp := Cl

END; { procedure ViewLineText.SetSymbolHelp }

{----------------------------------------------------------}

PROCEDURE ViewLineText.SetColorHelp ( Cl : BYTE );

          { ⠭ 梥 䮭 ⨢ ப }
BEGIN
     ColorHelp := Cl

END;  { procedure ViewLineText.SetColorHelp }

{----------------------------------------------------------}

PROCEDURE ViewLineText.SetColorInsert ( Cl : BYTE );

          { ⠭ 梥 ᨬ 뤥 ப }
BEGIN
     ColorInsert := Cl

END;  { procedure ViewLineText.SetColorInsert }

{----------------------------------------------------------}

PROCEDURE ViewLineText.show_inf;

          {   ࠭ ⥪饥 ﭨ ᬮ }
          {            ⨢஢               }
VAR
   x, y : BYTE;
   HelpList : RecLinePtr;
   Index : LONGINT;
   indx : INTEGER;
   stroka : String;
   Help : STRING;
   IndexX, EndX : WORD;

BEGIN
     IF ( Number < 1 ) THEN
        FatalError ( '室  < 1    Show_Inf' );

        { ४஢ न ᬥ饭 }

     IF ( key_ramka ) THEN
        x := 1
     ELSE
         x := 0;

       {  ଠ樨  ஬筮 ᯨ᪥ LinesList }

     SwapInformation;
     IF ( CodError <> 0 ) THEN
        EXIT;

       { ନ஢ ப - ⪨ }

     stroka := '';
     FOR indx := 1 TO size_x DO
         stroka := CONCAT ( stroka, ' ' );

       { ନ஢ ࠦ   }

     FOR indx := 1 TO size_y DO
         BEGIN
              IF ( ( indx + number - 1 ) <= MaxNumberInsertLines ) THEN
                 BEGIN
                      IF ( ( indx + number - 1 ) = NumberHelpLine ) THEN
                         BEGIN
                              WindowPtr^.SetColorSymbol ( ColorSymHelp );
                              WindowPtr^.SetColorFon ( ColorHelp )
                         END
                      ELSE
                          BEGIN
                               WindowPtr^.SetColorFon ( ColorFon );
                               IF ( ControlLine [ indx + number - 1 ]
                                    <> 0 ) THEN
                                  WindowPtr^.SetColorSymbol ( ColorInsert )
                               ELSE
                                   WindowPtr^.SetColorSymbol ( ColorText )
                          END
                 END;
              WindowPtr^.WPrint ( LO ( ( x + 1 ) ), LO ( ( indx + x ) ), stroka );
              HelpList := FindLine ( Indx, LinesList );
              IF ( HelpList <> NIL ) THEN
                 Help := HelpList^.Line
              ELSE
                  Help := '';
              EndX := PointBeginX + Size_X - 1;
              IF ( EndX > LENGTH ( Help ) ) THEN
                 EndX := LENGTH ( Help );
              IF ( ( indx + number - 1 ) <= end_number ) THEN
                  FOR IndexX := PointBeginX TO EndX DO
                      WindowPtr^.WChar ( LO ( ( X + IndexX - PointBeginX + 1) ),
                           LO ( ( indx + x ) ), Help [ IndexX ] );
         END;
     WindowPtr^.PrintWindow;
     WindowPtr^.SetColorFon ( ColorFon );
     WindowPtr^.SetColorSymbol ( ColorText )

END; { procedure ViewLineText.show_inf }

{----------------------------------------------------------}

PROCEDURE ViewLineText.Control_Inf ( VAR ext_byte : LONGINT );

         { 楤 ࠢ ଠ樥  }
         {        ⨢஢        }
VAR
   indx : WORD;
   OldSize : LONGINT;

BEGIN
     Ext_Byte := 0;
     IF ( CodError <> 0 ) THEN
        EXIT;
     FOR indx := 1 TO MaxNumberInsertLines DO
         ControlLine [ indx ] := 0;
     REPEAT
           show_inf;
           IF ( CodError <> 0 ) THEN
              EXIT;
           ch := GetKeyBoard;
           IF ( GetSingKey ) THEN
              BEGIN
                   ch := GetKeyBoard;
                   CASE ch OF
                        arrow_down : line_down;
                        arrow_up   : line_up;
                        arrow_Left : CharLeft;
                        arrow_Right: CharRight;
                        page_down  : window_down;
                        page_up    : window_up;
                        key_ins    : Insert;
                        key_end    : TextEnd;
                        key_home   : TextHome
                   ELSE
                       BEGIN
                            OldSize := TextStream^.GetSize;
                            run_for_key ( ch );
                            IF ( OldSize <> TextStream^.GetSize ) THEN
                               BEGIN
                                    end_number := TextStream^.GetSize;
                                    ClearListRecLine ( LinesList );
                                    LinesList := NIL
                               END
                       END
                   END
              END
     UNTIL ( ( ch IN [ #27, #$0D ] ) OR ( ( Ch = #0 ) AND ( SingAlt ) ) );
     IF ( ch <> #27 ) THEN
         ext_byte := NumberHelpLine
     ELSE
         ext_byte := 0

END; { procedure ViewLineText.Control_Inf }

{----------------------------------------------------------}

FUNCTION ViewLineText.TestLine ( num : LONGINT ) : BYTE;

         { ஢ઠ  ப  稥 }
         {            䫠 ⬥⪨            }
BEGIN
     IF ( ( num < 1 ) OR ( num > MaxNumberInsertLines ) OR ( Num > End_number) ) THEN
        BEGIN
             TestLine := 0;
             EXIT
        END;
     TestLine := ControlLine [ num ]

END; { function ViewLineText.TestLine }

{----------------------------------------------------------}

DESTRUCTOR ViewLineText.Done;

           { 樠 쥪 }
BEGIN
     ViewText.Done

END; { dectructor ViewLineText.Done }

{----------------------------------------------------------}

DESTRUCTOR ViewLineText.DoneWithStream;

           { 樠 쥪   ⮪ }
BEGIN
     ViewText.DoneWithStream

END; { dectructor ViewLineText.DoneWithStream }

{----------------------------------------------------------}

CONSTRUCTOR ViewLineNumberText.Init ( WindPtr : TextWindowPtr;
                                      Stream : POINTER );

           { 樠 쥪 }
VAR
   indx : WORD;

BEGIN
     ViewLineText.Init ( WindPtr, Stream );
     LastNumber := 0

END;  { constructor ViewLineNumberText.Init }

{----------------------------------------------------------}

PROCEDURE ViewLineNumberText.show_inf;

          {   ࠭ ⥪饥 ﭨ ᬮ }
          {            ⨢஢               }
VAR
   x, y : BYTE;
   HelpList : RecLinePtr;
   Index : LONGINT;
   indx : INTEGER;
   stroka : String;
   Help, Line : STRING;
   IndexX, EndX : WORD;

BEGIN
     IF ( Number < 1 ) THEN
        FatalError ( '室  < 1    Show_Inf' );

        { ४஢ न ᬥ饭 }

     IF ( key_ramka ) THEN
        x := 1
     ELSE
         x := 0;

       {  ଠ樨  ஬筮 ᯨ᪥ LinesList }

     SwapInformation;
     IF ( CodError <> 0 ) THEN
        EXIT;

       { ନ஢ ப - ⪨ }

     stroka := '';
     FOR indx := 1 TO size_x DO
         stroka := CONCAT ( stroka, ' ' );

       { ନ஢ ࠦ   }

     FOR indx := 1 TO size_y DO
         BEGIN
              IF ( ( indx + number - 1 ) <= MaxNumberInsertLines ) THEN
                 BEGIN
                      IF ( ( indx + number - 1 ) = NumberHelpLine ) THEN
                         BEGIN
                              WindowPtr^.SetColorSymbol ( ColorSymHelp );
                              WindowPtr^.SetColorFon ( ColorHelp )
                         END
                      ELSE
                          BEGIN
                               WindowPtr^.SetColorFon ( ColorFon );
                               IF ( ControlLine [ indx + number - 1 ]
                                    <> 0 ) THEN
                                  WindowPtr^.SetColorSymbol ( ColorInsert )
                               ELSE
                                   WindowPtr^.SetColorSymbol ( ColorText )
                          END
                 END;
              IF ( ( indx + number - 1 ) <= MaxNumberInsertLines ) THEN
                 BEGIN
                      IF ( ControlLine [ indx + number - 1 ] <> 0 ) THEN
                         BEGIN
                              STR ( ControlLine [ indx + number - 1], Line );
                              WHILE ( LENGTH ( Line ) < 3 ) DO
                                    Line := Line + ' ';
                              Line := Line + ' - '
                         END
                      ELSE
                          Line := '      '
                 END;
              WindowPtr^.WPrint ( LO ( ( x + 1 ) ), LO ( ( indx + x ) ), stroka );
              HelpList := FindLine ( Indx, LinesList );
              IF ( HelpList <> NIL ) THEN
                 Help := HelpList^.Line
              ELSE
                  Help := '';
              Help := Line + Help;
              EndX := PointBeginX + Size_X - 1;
              IF ( EndX > LENGTH ( Help ) ) THEN
                 EndX := LENGTH ( Help );
              IF ( ( indx + number - 1 ) <= end_number ) THEN
                  FOR IndexX := PointBeginX TO EndX DO
                      WindowPtr^.WChar ( LO ( ( X + IndexX - PointBeginX + 1) ),
                           LO ( ( indx + x ) ), Help [ IndexX ] );
         END;
     WindowPtr^.PrintWindow;
     WindowPtr^.SetColorFon ( ColorFon );
     WindowPtr^.SetColorSymbol ( ColorText )

END; { procedure ViewLineNumberText.show_inf }

{----------------------------------------------------------}

PROCEDURE ViewLineNumberText.Insert;

BEGIN
     IF ( NumberHelpLine > MaxNumberInsertLines ) THEN
        EXIT;
     IF ( ControlLine [ NumberHelpLine ] = 0 ) THEN
         BEGIN
              INC ( LastNumber );
              ControlLine [ NumberHelpLine ] := LastNumber
         END
     ELSE
         IF ( ControlLine [ NumberHelpLine ] = LastNumber ) THEN
            BEGIN
                 ControlLine [ NumberHelpLine ] := 0;
                 DEC ( LastNumber )
            END;
     show_inf

END; { procedure ViewLineNumberText.Insert }

{----------------------------------------------------------}

END.
